import { Component } from '@angular/core';
import { CancellationRequestService } from '../services/cancellation-request.service';

@Component({
  selector: 'app-cancellation-request',
  templateUrl: './cancellation-request.component.html',
  styleUrls: ['./cancellation-request.component.css'],
})
export class CancellationRequestComponent {
  statusList: any = [];
  selectedStatusList: any;
  transactionNo: any = '';
  remark: any = '';

  constructor(private cancelRequestSvc: CancellationRequestService) {}

  ngOnInit(): void {
    this.getStatusList();
  }

  getStatusList() {
    this.cancelRequestSvc.getStatusList().subscribe({
      next: (res: any) => {
        this.statusList = res;
        this.selectedStatusList = res?.[0]?.TrStatusID;
      },
      error: () => {
        this.statusList = [];
      },
      complete: () => {},
    });
  }

  updateCancelRequest() {
    if (!this.transactionNo) {
      alert('Please Enter Transaction Number!');
      return;
    }

    if (!this.selectedStatusList) {
      alert('Please Select Status!');
      return;
    }

    if (!this.remark) {
      alert('Please Enter Remarks!');
      return;
    }

    let payload: any = {};

    payload = {
      SRTRNo: this.transactionNo,
      txtRemarks: this.remark,
      UserID: 1,
      UserGroup: 0,
      Agent_Branch_ID: 0,
      SubUserGroup_Id: 1,
      TrStatusID: this.selectedStatusList,
    };
    this.cancelRequestSvc.updateCancelRequest(payload).subscribe({
      next: (res: any) => {},
      error: (err) => {
        alert(err?.error?.message || 'Something went wrong');
      },
      complete: () => {},
    });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
