import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class CountryMandatoryFieldService {
  constructor(private http: HttpClient) {}

  getTypesOfMandatory() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/add-mandetory-field/type-of-mandatory`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCountryType() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/add-mandetory-fieldcountry-type`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCountryList(CountryType: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/add-mandetory-field/country-list?CountryType=${CountryType}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getModeOfPayment(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/add-mandetory-field/mode-of-payment?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getGrid(
    ValidationTypeID: any,
    PermissionID: any,
    CountryID: any,
    ModeOfPayment_ID: any,
  ) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/add-mandetory-field/grid?ValidationTypeID=${ValidationTypeID}&CountryID=${CountryID}&PermissionID=${PermissionID}&ModeOfPayment_ID=${ModeOfPayment_ID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
