import { NgModule } from '@angular/core';
import { CommonModule, DatePipe } from '@angular/common';

import { DashboardRoutingModule } from './dashboard-routing.module';
import { RemoveTransactionComponent } from '../remove-transaction/remove-transaction.component';
import { BlockUnblockTransactionComponent } from '../block-unblock-transaction/block-unblock-transaction.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ViewPendingApprovalComponent } from '../view-pending-approval/view-pending-approval.component';
import { SendAgentsCtaTransactionsComponent } from '../send-agents-cta-transactions/send-agents-cta-transactions.component';
import { BeneficiaryRegistrationComponent } from '../beneficiary-registration/beneficiary-registration.component';

@NgModule({
  declarations: [
    RemoveTransactionComponent,
    BlockUnblockTransactionComponent,
    ViewPendingApprovalComponent,
    SendAgentsCtaTransactionsComponent,
    BeneficiaryRegistrationComponent,
  ],
  imports: [
    CommonModule,
    DashboardRoutingModule,
    FormsModule,
    ReactiveFormsModule,
  ],
  providers: [DatePipe],
})
export class DashboardModule {}
