import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';
import { HttpClient } from '@angular/common/http';

@Injectable({
  providedIn: 'root',
})
export class ManageCifWiseCommissionService {
  constructor(private http: HttpClient) {}

  getSendCountry() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/send-country-list?userId=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgent(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/send-agent-list?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountryList(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/receive-country-list?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveAgentList(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/receive-agent-list?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getModeOfPayment() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/mode-Of-payment`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSubAgentList(ReceAgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/sub-agent?ReceAgentID=${ReceAgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getAllRecord(
    ReceivingAgentID: any,
    SendCountryID: any,
    ReceiveCountryID: any,
    AgentID: any,
    ModeOfPaymentID: any,
    ReceivingSubAgentID: any
  ) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/all-record?ReceivingAgentID=${ReceivingAgentID}&SendCountryID=${SendCountryID}&ReceiveCountryID=${ReceiveCountryID}
      &AgentID=${AgentID}&ModeOfPaymentID=${ModeOfPaymentID}&ReceivingSubAgentID=${ReceivingSubAgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  deleteRecord(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/delete`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCountryInsert() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/country-wise-commission/sendcountry-insert`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentInsert(PayInCountryId: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/agent-insert?PayInCountryId=${PayInCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCurrencyInsert(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/sendcurrency-insert?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCifNumber() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/cif-number-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getInsertReceiveCountry() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/country-wise-commission/receivecountry-insert`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentInsertList(currencyId: any = 0, countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/receiveagent-insert?CurrencyID=${currencyId}&CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCurrencyInsert(payOutCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/receivecurrency-insert?CountryId=${payOutCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getModeOfPaymentInsert() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/mode-of-payment-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getReceiveAgentInsert(receiveCurrencyId: any = 0, payOutCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/receiveagent-insert?CurrencyID=${receiveCurrencyId}&CountryID=${payOutCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveSubAgentInsert(agentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/receivesubagent-insert?AgentId=${agentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getRangeCurrencyInsert() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/rangecurrency-insert`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTotalCommissionType() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/country-wise-commissionn/totalcommission-type-insert`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addRecord(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/insert`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  edit(ID: any, IsSubAgent: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/edit-record?ID=${ID}&IsSubAgent=${IsSubAgent}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateRecord(payload: any) {
    return this.http.patch(
      `${environment.apiUrl}/v1/api/master/cif-wise-commission/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
