import { Component } from '@angular/core';
import { ManageRemitterOccupationService } from '../services/manage-remitter-occupation.service';

@Component({
  selector: 'app-manage-remitter-occupation',
  templateUrl: './manage-remitter-occupation.component.html',
  styleUrls: ['./manage-remitter-occupation.component.css'],
})
export class ManageRemitterOccupationComponent {
  occupationList: any = [];
  selectedOccupation: any = '0';
  remitterOccupation: any = [];

  constructor(private remitterOccupationSvc: ManageRemitterOccupationService) {}

  ngOnInit(): void {
    this.getOccupationList();
    this.getAllRecord();
  }

  getOccupationList() {
    this.remitterOccupationSvc.getOccupationList().subscribe({
      next: (res: any) => {
        this.occupationList = res;
      },
      error: (err) => {
        this.occupationList = [];
      },
      complete: () => {},
    });
  }

  getAllRecord(occupationName: any = 0) {
    this.remitterOccupationSvc.getAllRecord(occupationName).subscribe({
      next: (res: any) => {
        this.remitterOccupation = res;
      },
      error: (err) => {
        this.remitterOccupation = [];
      },
      complete: () => {},
    });
  }

  filter() {
    if (this.selectedOccupation) {
      this.getAllRecord(this.selectedOccupation);
    }
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
