import { Component, ViewChild, TemplateRef } from '@angular/core';
import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';
import { FormBuilder } from '@angular/forms';

@Component({
  selector: 'app-rejected-customer',
  templateUrl: './rejected-customer.component.html',
  styleUrls: ['./rejected-customer.component.css'],
})
export class RejectedCustomerComponent {
  bsModalRef: BsModalRef;

  @ViewChild('editCustomerRegistration')
  editCustomerRegistrationTemplate: TemplateRef<any>;
  selectedSearchOption: string = 'all';
  customerNumber: string = '';
  firstName: string = '';
  fromDate: string = '';
  toDate: string = '';
  editedCustomer: any = {};

  constructor(private modalService: BsModalService, private fb: FormBuilder) {
    this.createForm();
  }

  createForm() {}

  search() {
    console.log('Search method called.');
  }

  editRejectedCustomer() {
    console.log('Edit Rejected Customer method called.');
    this.bsModalRef = this.modalService.show(
      this.editCustomerRegistrationTemplate,
      { class: 'modal-lg' }
    );
    this.editedCustomer = {
      firstName: 'John', // Example data
    };
  }

  updateCustomer() {
    console.log('Update Customer method called.');

    this.bsModalRef.hide();
  }

  resetForm() {
    console.log('Reset Form method called.');
    this.editedCustomer = {};
  }
}
