import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { getCacheData } from './utils/helper';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class RemoveTransactionService {
  constructor(private http: HttpClient) {}

  getAllRecord(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/all-record`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getStatus() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/status`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentType(AgentId: any = -1, AgentGroupID: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/agent-type?AgentGroupID=${AgentGroupID}&AgentId=${AgentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCountry() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/send-country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCurrency(SendCountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/send-currency?SendCountryID=${SendCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgent(AgentID: any, TargetCountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/agent?AgentID=${AgentID}&TargetCountryID=${TargetCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentBranch(AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/agent-branch?AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountry(CountryID) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/receive-country?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCurrency(ReceiveCountryID) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/receive-currency?ReceiveCountryID=${ReceiveCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getUser(AgentBranchID: any, AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/user?AgentBranchID=${AgentBranchID}&AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransferType(GroupID: any, AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/remove-payment/transfer-type?AgentID=${AgentID}&GroupID=${GroupID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
