import { Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RemoveTransactionService } from '../remove-transaction.service';
import { CountryManagementComponent } from '../country-management/country-management.component';

@Component({
  selector: 'app-remove-transaction',
  templateUrl: './remove-transaction.component.html',
  styleUrls: ['./remove-transaction.component.css'],
})
export class RemoveTransactionComponent {
  constructor(private RemoveTransactionSvc: RemoveTransactionService) {}

  public searchByType: any = 2;
  AgentTypeID: any = 0;
  AgentList: any;
  Status: any;
  ReceiveCurrency: any;
  AgentBranchList: any;
  baseCountries: any[] = [];
  status: any[] = [];
  TransferTypeList: any[] = [];
  payinCountryList: any[] = [];
  CountryID: any = 0;
  Users: any;
  TransferType: any;
  transactionNo: string;
  startDate: string;
  endDate: string;
  customerNameFirst: string;
  customerNameLast: string;
  beneficiaryNameFirst: string;
  beneficiaryNameLast: string;
  AgentType: any;
  ReceiveCountry: any;
  AgentID: any;
  data: any[] = [];
  SendCountry: any;
  SendCurrency: any;

  
  ngOnInit(): void {
    this.getStatus();
    this.getAgentType();
    this.getSendCountry();
    this.getReceiveCountry();
  }

  SearchType(event: any) {
    this.searchByType = parseInt(event.target.value, 10);
    console.log('this.searchByType: ', this.searchByType);
  }

  onChangeStatus(event: any) {}

  filterBySearchFields() {}

  filterByTransactionNo() {
    const payload = {
      TopRecord: 0,
      SRTRNo: this.transactionNo,
      StatusID: 0,
      flag: 0,
      SearchByType: this.searchByType,
      UserGroupType: -1,
      G_Agent_ID: -1,
      AgentBranchId: -1,
      UserID: 0,
      Agent_ID: -1,
      TrTypeID: -1,
      PayInCountryID: -1,
      PayInCurrencyID: -1,
      PayOutCountryID: -1,
      PayOutCurrencyID: -1,
      LoginAgentCountry: -1,
      LoginAgentCity: -1,
      LoginAgentLocation: -1,
    };
    this.RemoveTransactionSvc.getAllRecord(payload).subscribe((res) => {
      res;
    });
  }

  getStatus() {
    this.RemoveTransactionSvc.getStatus().subscribe((res) => {
      this.Status = res;
    });
  }

  getAgentType() {
    this.RemoveTransactionSvc.getAgentType().subscribe((res) => {
      this.AgentType = res;
    });
  }
  onSelectAgentType(AgentTypeID) {
    this.getAgent();
  }
  getSendCountry() {
    this.RemoveTransactionSvc.getSendCountry().subscribe((res) => {
      this.SendCountry = res;
    });
  }

  getSendCurrency(CountryId) {
    this.RemoveTransactionSvc.getSendCurrency(CountryId).subscribe((res) => {
      this.SendCurrency = res;
    });
  }

  getAgent() {
    this.RemoveTransactionSvc.getAgent(
      this.AgentTypeID,
      this.CountryID
    ).subscribe((res) => {
      this.AgentList = res;
    });
  }

  getAgentBranch(AgentID) {
    this.RemoveTransactionSvc.getAgentBranch(AgentID).subscribe((res) => {
      this.AgentBranchList = res;
    });
  }

  onSelectAgent(AgentID) {
    this.AgentID = AgentID;
    this.getAgentBranch(AgentID);
    this.getTransferType();
  }

  onSelectAgentBranch(AgentBranchID) {
    this.getUser(AgentBranchID);
  }

  getUser(AgentBranchID) {
    this.RemoveTransactionSvc.getUser(AgentBranchID, this.AgentID).subscribe(
      (res) => {
        this.Users = res;
      }
    );
  }

  getTransferType(GroupID: any = 0) {
    this.RemoveTransactionSvc.getTransferType(GroupID, this.AgentID).subscribe(
      (res) => {
        this.TransferType = res;
      }
    );
  }
  onSelectSendCountry(countryId) {
    this.CountryID = countryId;
    this.getSendCurrency(countryId);
    this.getAgent();
    this.getReceiveCountry();
  }

  getReceiveCountry() {
    this.RemoveTransactionSvc.getReceiveCountry(this.CountryID).subscribe(
      (res) => {
        this.ReceiveCountry = res;
      }
    );
  }

  onSelectReceiveCountry(ReceiveCountryID) {
    this.getReceiveCurrency(ReceiveCountryID);
  }

  getReceiveCurrency(ReceiveCountryID) {
    this.RemoveTransactionSvc.getReceiveCurrency(ReceiveCountryID).subscribe(
      (res) => {
        this.ReceiveCurrency = res;
      }
    );
  }

  filterByAdvanceSearchFields() {}

  clearCriteria() {}

  editTransaction(transaction: any) {}

  ViewLast(event: any) {}
  searchByTypeChange(event: any): void {}
  filter() {
    console.log('Filter function called');
  }
}
