import { Component } from '@angular/core';
import { ViewCancelTransactionService } from '../services/view-cancel-transaction.service';
import { ViewReceiveTransactionService } from '../services/view-receive-transaction.service';

@Component({
  selector: 'app-view-receive-transaction',
  templateUrl: './view-receive-transaction.component.html',
  styleUrls: ['./view-receive-transaction.component.css'],
})
export class ViewReceiveTransactionComponent {
  countryList: any = [];
  selectedCountryList: any;
  agentList: any = [];
  selectedAgentList: any;
  agentBranchList: any = [];
  selectedAgentBranchList: any = 'All';
  statusList: any = [];
  selectedStatusList: any = 'All';
  transactionNo: any = '';

  startDate: any;
  endDate: any;

  allCancelTransactions: any = [];
  selectedFileFormat: any = '1';

  constructor(
    private viewCancelTransactionSvc: ViewCancelTransactionService,
    private viewReceiveTransactionSvc: ViewReceiveTransactionService
  ) {}

  ngOnInit(): void {
    this.getCountryList();
    this.getStatusList();
  }

  getCountryList() {
    this.viewReceiveTransactionSvc.getCountryList().subscribe({
      next: (res: any) => {
        this.countryList = res;
        this.selectedCountryList = res?.[0]?.CountryId;
        this.getAgentList(res?.[0]?.CountryId);
      },
      error: () => {
        this.countryList = [];
      },
      complete: () => {},
    });
  }

  onCountryChange(countryId: any) {
    if (countryId != 0) {
      this.getAgentList(countryId);
    }
  }

  getAgentList(countryId: any = 0) {
    this.viewReceiveTransactionSvc.getAgentList(countryId).subscribe({
      next: (res: any) => {
        this.agentList = res;
        this.selectedAgentList = res?.[0]?.Agent_ID;
      },
      error: () => {
        this.agentList = [];
      },
      complete: () => {},
    });
  }

  onAgentChange(agentId: any) {
    if (agentId != 'All') {
      this.getAgentBranchList(agentId);
    }
  }

  getAgentBranchList(agentId: any = 0) {
    this.viewReceiveTransactionSvc.getAgentBranchList(agentId).subscribe({
      next: (res: any) => {
        this.agentBranchList = res;
      },
      error: () => {
        this.agentBranchList = [];
      },
      complete: () => {},
    });
  }

  getStatusList() {
    this.viewReceiveTransactionSvc.getStatusList().subscribe({
      next: (res: any) => {
        this.statusList = res;
      },
      error: () => {
        this.statusList = [];
      },
      complete: () => {},
    });
  }

  filterByTransactioNo() {
    if (!this.transactionNo) {
      alert('Please Enter Transaction No!');
      return;
    }
    let payload: any = {};
    payload = {
      TransactionNo: this.transactionNo,
    };
    this.viewCancelTransactionSvc.getFillGrid(payload).subscribe({
      next: (res: any) => {
        this.allCancelTransactions = res;
      },
      error: (err) => {
        this.allCancelTransactions = [];
        alert(err?.error?.message || 'Something went wrong');
      },
      complete: () => {},
    });
  }

  displayByDate() {
    if (!this.startDate && !this.endDate) {
      alert('Please Select Start & End Date!');
      return;
    }

    let countryId = -1;
    if (this.selectedCountryList != 0) {
      countryId = this.selectedCountryList;
    }
    let payload: any = {};
    payload = {
      TransactionNo: '',
      DdlCountryID: countryId,
      DdlAgentsID: this.selectedAgentList,
      DrpAgentBranch: this.selectedAgentBranchList,
      StartDate: this.startDate,
      EndDate: this.endDate,
      // DrpCancelledTypeID: this.selectedCancelledType,
      DrpStatusID: this.selectedStatusList,
      SubUserGroup_Id: 0,
    };
    this.viewCancelTransactionSvc.getFillGrid(payload).subscribe({
      next: (res: any) => {
        this.allCancelTransactions = res;
      },
      error: (err) => {
        this.allCancelTransactions = [];
        alert(err?.error?.message || 'Something went wrong');
      },
      complete: () => {},
    });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
